﻿using UniversityContracts.BindingModels;
using UniversityContracts.ViewModels;
using UniversityDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace UniversityDatabaseImplement.Models
{
    public class User : IUserModel
    {
        public int Id { get; set; }
        [Required]
        public string Name { get; set; } = string.Empty;
        [Required]
        public string Surname { get; set; } = string.Empty;
        [Required]
        public string PhoneNumber { get; set; } = string.Empty;
        [Required]
        public string Position { get; set; } = string.Empty;
        [Required]
        public string Login { get; set; } = string.Empty;
        [Required]
        public string Password { get; set; } = string.Empty;
        public static User Create(UserBindingModel model)
        {
            return new User
            {
                Id = model.Id,
                Name = model.Name,
                Surname = model.Surname,
                PhoneNumber = model.PhoneNumber,
                Position = model.Position,
                Login = model.Login,
                Password = model.Password
            };
        }

        public void Update(UserBindingModel model)
        {
            if (model == null) return;

            Id = model.Id;
            Name = model.Name;
            Surname = model.Surname;
            PhoneNumber = model.PhoneNumber;
            Position = model.Position;
            Login = model.Login;
            Password = model.Password;
        }

        public UserViewModel GetViewModel => new()
        {
            Id = Id,
            Name = Name,
            Surname = Surname,
            PhoneNumber = PhoneNumber,
            Position = Position,
            Login = Login,
            Password = Password
        };
    }
}
